# mypy-boto3-codeguru-reviewer

[![PyPI - mypy-boto3-codeguru-reviewer](https://img.shields.io/pypi/v/mypy-boto3-codeguru-reviewer.svg?color=blue)](https://pypi.org/project/mypy-boto3-codeguru-reviewer)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-codeguru-reviewer.svg?color=blue)](https://pypi.org/project/mypy-boto3-codeguru-reviewer)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)

Type annotations for
[boto3.CodeGuruReviewer 1.16.13](https://boto3.amazonaws.com/v1/documentation/api/1.16.13/reference/services/codeguru-reviewer.html#CodeGuruReviewer) service
compatible with
[VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright)
and other tools.

Generated by [mypy-boto3-buider 3.2.2](https://github.com/vemel/mypy_boto3_builder).

More information can be found on [boto3-stubs](https://pypi.org/project/boto3-stubs/) page.

- [mypy-boto3-codeguru-reviewer](#mypy-boto3-codeguru-reviewer)
  - [How to install](#how-to-install)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)
    - [Waiters annotations](#waiters-annotations)
    - [Service Resource annotations](#service-resource-annotations)
    - [Other resources annotations](#other-resources-annotations)
    - [Collections annotations](#collections-annotations)
    - [Typed dictionations](#typed-dictionations)

## How to install

Install `boto3-stubs` for `CodeGuruReviewer` service.

```bash
python -m pip install boto3-stubs[codeguru-reviewer]
```

## Usage

### VSCode

- Install [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto-stubs[codeguru-reviewer]` in your environment: `python -m pip install 'boto3-stubs[codeguru-reviewer]'`

Both type checking and auto-complete should work for `CodeGuruReviewer` service.
No explicit type annotations required, write your `boto3` code as usual.

### PyCharm

- Install `boto-stubs[codeguru-reviewer]` in your environment: `python -m pip install 'boto3-stubs[codeguru-reviewer]'`

Both type checking and auto-complete should work for `CodeGuruReviewer` service.
No explicit type annotations required, write your `boto3` code as usual.
Auto-complete can be slow on big projects or if you have a lot of installed `boto3-stubs` submodules.

### Other IDEs

Not tested, but as long as your IDE support `mypy` or `pyright`, everything should work.

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto-stubs[codeguru-reviewer]` in your environment: `python -m pip install 'boto3-stubs[codeguru-reviewer]'`
- Run `mypy` as usual

Type checking should work for `CodeGuruReviewer` service.
No explicit type annotations required, write your `boto3` code as usual.

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `boto-stubs[codeguru-reviewer]` in your environment: `python -m pip install 'boto3-stubs[codeguru-reviewer]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `CodeGuruReviewer` service.
No explicit type annotations required, write your `boto3` code as usual.

## Explicit type annotations

### Client annotations

`CodeGuruReviewerClient` provides annotations for `boto3.client("codeguru-reviewer")`.

```python
import boto3

from mypy_boto3_codeguru_reviewer import CodeGuruReviewerClient

client: CodeGuruReviewerClient = boto3.client("codeguru-reviewer")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: CodeGuruReviewerClient = session.client("codeguru-reviewer")
```

### Paginators annotations

`mypy_boto3_codeguru_reviewer.paginator` module contains type annotations for all paginators.

```python
from mypy_boto3_codeguru_reviewer import CodeGuruReviewerClient
from mypy_boto3_codeguru_reviewer.paginator import ListRepositoryAssociationsPaginator

client: CodeGuruReviewerClient = boto3.client("codeguru-reviewer")

# Explicit type annotations are optional here
# Type should be correctly discovered by mypy and IDEs
# VSCode requires explicit type annotations
list_repository_associations_paginator: ListRepositoryAssociationsPaginator = client.get_paginator("list_repository_associations")
```







### Typed dictionations

`mypy_boto3_codeguru_reviewer.type_defs` module contains structures and shapes assembled
to typed dictionaries for additional type checking.

```python
from mypy_boto3_codeguru_reviewer.type_defs import (
    AssociateRepositoryResponseTypeDef,
    CodeCommitRepositoryTypeDef,
    CodeReviewSummaryTypeDef,
    CodeReviewTypeDef,
    CodeReviewTypeTypeDef,
    CommitDiffSourceCodeTypeTypeDef,
    CreateCodeReviewResponseTypeDef,
    DescribeCodeReviewResponseTypeDef,
    DescribeRecommendationFeedbackResponseTypeDef,
    DescribeRepositoryAssociationResponseTypeDef,
    DisassociateRepositoryResponseTypeDef,
    ListCodeReviewsResponseTypeDef,
    ListRecommendationFeedbackResponseTypeDef,
    ListRecommendationsResponseTypeDef,
    ListRepositoryAssociationsResponseTypeDef,
    MetricsSummaryTypeDef,
    MetricsTypeDef,
    PaginatorConfigTypeDef,
    RecommendationFeedbackSummaryTypeDef,
    RecommendationFeedbackTypeDef,
    RecommendationSummaryTypeDef,
    RepositoryAnalysisTypeDef,
    RepositoryAssociationSummaryTypeDef,
    RepositoryAssociationTypeDef,
    RepositoryHeadSourceCodeTypeTypeDef,
    RepositoryTypeDef,
    SourceCodeTypeTypeDef,
    ThirdPartySourceRepositoryTypeDef,
)

def get_structure() -> CodeCommitRepositoryTypeDef:
    return {
      ...
    }
```
